base/urls.py
from django.urls import path, include

from . import views
app_name = 'base'

urlpatterns = [
    path('', views.index, name='index'),
]

data_mining_age/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('landing.urls')),
    path('admin/', admin.site.urls, name='admin_page'),
    path('base/', include('base.urls')),
    path('harvester/', include('harvester.urls')),
]

harvester/urls.py
from django.urls import path
from django.utils.translation import gettext_lazy as _
from . import views

app_name = 'harvester'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:leaderboard_id>/', views.loading, name='loading'),
    path('archive/', views.archive, name='archive')
    # path('<str:games>/<int:leaderboard_id>/',  views.results, name='results')
]

landing/urls.py
from django.urls import path, include

from . import views

app_name = 'landing'
urlpatterns = [
    path('', views.index, name='index'),
    path('harvester/', include('harvester.urls') )
]

base/models.py
from django.db import models
from picklefield.fields import PickledObjectField

# Create your models here.
class Player(models.Model):
    name = models.CharField(max_length=50, help_text='Player name')
    steam_id = models.IntegerField(help_text='Steam id')
    elo = PickledObjectField(help_text='Dictionary with Elos')
    rank = PickledObjectField(help_text='Dictionary with ranking')

harvester/models.py
from django.db import models
# Create your models here.


class Leaderboard(models.Model):
    game = models.CharField(max_length=10, help_text='AoE2:DE o AoE2:HD')
    leaderboard_id = models.IntegerField(help_text='Id type of the leaderboard')
    date = models.DateTimeField(help_text='Collection date')
    csv_table = models.FilePathField(help_text='Path to the CSV file storing the dataset')
    population = models.IntegerField(help_text='Total number of players')
    average_elo = models.FloatField(help_text='Average elo')
    plot = models.TextField(null=True, help_text='Path to the HTML plot of the dataset')
    top_player = models.CharField(null=True, help_text='Top ranking player', max_length=100)

landing/models.py
from django.db import models

# Create your models here.

base/views.py
from django.shortcuts import render

# Create your views here.
def index(request):
    return render(request, 'base/index.html')

harvester/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from django.urls import reverse
from utils.utils import harvest_leaderboard, create_plot
from .models import Leaderboard
from django.conf import settings


# Create your views here.
def index(request):

    if request.method == 'POST' and 'run_script' in request.POST:
        return redirect('harvester:loading', leaderboard_id = int(request.POST['choice']))

    else:
        print('First landing')
        return render(request, 'harvester/index.html', context={'titles': settings.TITLES})
#
# def result(request, db_id):
#     print('Plotting leaderboard {n}'.format(n=db_id))
#     leaderboard = get_object_or_404(Leaderboard, pk=db_id)
#     fig = create_plot(leaderboard)
#     context = {
#                'plot_div' : fig,
#                'leaderboard' : leaderboard
#                 }
#     return render(request, 'harvester/result.html', context = context)

def loading(request, leaderboard_id):
    base_url = 'https://aoe2.net/api/leaderboard?game={code}&leaderboard_id={leaderboard_id}&start={start}&count={count}'
    leaderboard = harvest_leaderboard(base_url, leaderboard_id)
    #print(reverse('harvester:result'))
#    return redirect('harvester:result', db_id = leaderboard.id)
    # print('Plotting leaderboard {n}'.format(n=db_id))
    # leaderboard = get_object_or_404(Leaderboard, pk=db_id)
    leaderboard.plot = create_plot(leaderboard)
    leaderboard.save()
    context = {
                'leaderboard' : leaderboard
                }
    print(leaderboard.plot)
    return render(request, 'harvester/result.html', context = context)

#    return redirect('harvester:result', leaderboard = leaderboard)

def archive(request):
    context = {

    }
    return render(request, 'harvester/archive.html', context = context)

landing/views.py
from django.shortcuts import render

# Create your views here.

def index(request):
    return render(request, 'landing/index.html')

base/templates/base/index.html
{% extends "base.html" %}

{% block section_title %}<h1>Base index</h1>{% endblock section_title %}

harvester/templates/harvester/archive.html
{% extends "base.html" %}

harvester/templates/harvester/index.html
{% extends "base.html" %}
{% load static %}
{% block header %}
  <script>
  function showPage() {
    document.getElementById("first").style.display = "none";
    document.getElementById("loader").style.display = "block";
    document.getElementById("second").style.display = "block";
  }
  </script>
  <link rel="stylesheet" href="{% static "harvester/css/loader.css" %}">
  <style>
    .button1 {
      color: white;
      background-color: #555555;
      border-radius: 8px;
      border: 2px solid #555555;
    }
    .button1:hover {
      background-color:  #e7e7e7 ;
      color:  #555555;
    }

  </style>
{% endblock header %}
{% block section_title %}
<div>
  <h1>Some Text</h1>
</div>
{% endblock section_title %}

{% block content %}

<div class='container-fluid' style='margin-top: 15px'>
  <div class="row"  id='first'>
    <div class="col-sm-6" style="margin-top: 10px">
      Let's harvest some data! Select the leaderboard to scrape:
    </div>

    <div class="col-sm-6" style="text-align: center; margin-top: 10px">
      <form method="post">
        {% csrf_token %}
        <select name="choice">
            {% for index, text in titles.items %}
            <option value="{{ index }}">{{ text }}</option>
            {% endfor %}
        </select>
          <button class="button button1" type="submit" name="run_script" onclick="showPage()">Run harvest</button>
      </form>
    </div>

  </div>

  <div class="row">
    <div id="loader"></div>
  </div>
  <div class="row" id="second" style="display:none">
    Some text just to try
  </div>

</div>




{% endblock content %}

harvester/templates/harvester/result.html
{% extends "base.html" %}
{% load humanize %}
{% block content %}
<div class="container-fluid">
  <div class="row">
    <div class="col-sm-12" style="text-align: center;">
      <h1>Results</h1>
    </div>
  </div>
  <div class="row">
    <div class="col-sm-6">
      The plot is interactive! <br>
      It counts the number of players  (y axis) at a certain Elo (x axis, grouped with a bin of 5 points)
    </div>
    <div class="col-sm-6">
      <ul>
         <li>Number of players: {{ leaderboard.population }}</li>
         <li>Average Elo: {{ leaderboard.average_elo|floatformat:2 }}</li>
         <li>Top player: {{ leaderboard.top_player }}</li>
       </ul>
    </div>
  </div>
</div>


  {% autoescape off %}
  {{ leaderboard.plot }}
  {% comment %} {% include leaderboard.csv_table %} {% endcomment %}
  {% endautoescape %}
{% endblock content %}

landing/templates/landing/index.html
{% extends "base.html" %}
{% load static %}
{% block page_title %}Test title{% endblock page_title %}


{% block section_title %}
<div class="jumbotron jumbotron-fluid bg-secondary" style="margin-bottom:0; max-height:125px; padding-top:10px">
  <div class="page-header">
  	<h1>Age of Empires 2<br /><small class="text-white-50">Data Mining Edition</small></h1>
  </div>
</div>
{% endblock section_title %}
{% block content %}
<div class="container-fluid" style="margin-top: 25px">
  <div class="row">
    <div class="col-sm-8">
      <a href="{% url 'harvester:index' %}">Go have fun!</a>
    </div>
    <div class="col-sm--4">
      {% autoescape off %}
        <script src='https://redditjs.com/subreddit.js' data-subreddit='aoe2', data-subreddit-mode='grid'></script>
      {% endautoescape %}

    </div>
  </div>
</div>
{% endblock %}

templates/base.html
{% load static %}

<!DOCTYPE html>
<html>
    <head>
      <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
      {% block style %}
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
        <link rel="stylesheet" href="{% static "style.css" %}" />
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
      {% endblock style %}

      <title>{% block page_title %}Default title{% endblock page_title %}</title>
      {% block script_engine %}
        <!-- jQuery library -->
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
        <!-- Popper JS -->
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
        <!-- Latest compiled JavaScript -->
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
      {% endblock script_engine %}
      {% block header %}{% endblock header %}
    </head>

    <body>
    {% block section_title %}{% endblock section_title %}
    {% block navigation %}
    {% include "navigation.html" %}
    {% endblock navigation %}
    {% block content %}
    {% endblock content %}
    </body>
</html>

templates/navigation.html
<nav class="navbar navbar-expand-sm bg-dark navbar-dark sticky-top">
  <a class="navbar-brand" href="{% url 'landing:index' %}"><i class="fas fa-home"></i></a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#collapsibleNavbar">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="collapsibleNavbar">
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" href="{% url 'harvester:index' %}">Leaderboards</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url 'base:index' %}">Players</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="{% url 'harvester:archive' %}">Archive</a>
      </li>
    </ul>
  </div>
</nav>